<!-- 设备分类属性列表 -->
<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      ref="queryFormRef"
      :inline="true"
      :model="queryParams"
      class="-mb-15px"
      label-width="68px"
    >
      <el-form-item>
        <el-button @click="handleQuery">
          <Icon class="mr-5px" icon="ep:search" />
          搜索
        </el-button>
        <el-button @click="resetQuery">
          <Icon class="mr-5px" icon="ep:refresh" />
          重置
        </el-button>
        <el-button
          v-hasPermi="[`rq:iot-model-template-attrs:create`]"
          plain
          type="primary"
          @click="openForm('create')"
        >
          <Icon class="mr-5px" icon="ep:plus" />
          添加属性
        </el-button>
      </el-form-item>
      <el-form-item label="所属模板:" style="width: 200px" label-width="100px">
        <span>
          {{modelName}}
        </span>
      </el-form-item>
    </el-form>
  </ContentWrap>
  <!-- 列表 -->
  <ContentWrap>
    <el-tabs>
      <el-table v-loading="loading" :data="list" :show-overflow-tooltip="true" :stripe="true">
        <el-table-column align="center" label="属性名称" prop="name" />
<!--        <el-table-column align="center" label="标识符" prop="code" />-->
        <el-table-column align="center" label="数据类型" prop="type">
          <template #default="{ row }">
            {{ dataTypeOptionsLabel(row.selectOptions?.type) ?? '-' }}
          </template>
        </el-table-column>
        <!--
        <el-table-column align="left" label="数据定义" prop="code">
          <template #default="{ row }">
            <DataDefinition :data="row" />
          </template>
        </el-table-column>
        -->
        <el-table-column align="center" label="操作">
          <template #default="scope">
            <el-button
              v-hasPermi="[`rq:iot-model-template-attrs:update`]"
              link
              type="primary"
              @click="openForm('update', scope.row.id)"
            >
              编辑
            </el-button>
            <el-button
              v-hasPermi="['rq:iot-model-template-attrs:delete']"
              link
              type="danger"
              @click="handleDelete(scope.row.id,scope.row.deviceCategoryId)"
            >
              删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <!-- 分页 -->
      <Pagination
        v-model:limit="queryParams.pageSize"
        v-model:page="queryParams.pageNo"
        :total="total"
        @pagination="getList"
      />
    </el-tabs>
  </ContentWrap>
  <!-- 表单弹窗：添加/修改 -->
  <AttrTemplateModelForm ref="formRef" @success="getList" :deviceCategoryId="deviceCategoryId" />
</template>
<script lang="ts" setup>
import { DeviceAttrModelApi, DeviceAttrModelData } from '@/api/pms/modelattrtemplate'
import AttrTemplateModelForm from './AttrTemplateModelForm.vue'
import { getDataTypeOptionsLabel } from './config'
import { DataDefinition } from '../components'
import {useTagsViewStore} from "@/store/modules/tagsView";

const { delView } = useTagsViewStore() // 视图操作
const route = useRoute()
const { currentRoute } = useRouter()

defineOptions({ name: 'ModelAttrTemplate' })

const deviceCategoryId = route.params.id.split(",")[0] // 设备分类id
const categoryName = route.params.id.split(",")[1];//设备分类名称
const modelName = route.params.id.split(",")[2];//模板名称
const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const loading = ref(true) // 列表的加载中
const list = ref<DeviceAttrModelData[]>([]) // 列表的数据
const list1 = ref<DeviceAttrModelData[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  type: undefined,
  deviceCategoryId: -1
})

const queryFormRef = ref() // 搜索的表单
const dataTypeOptionsLabel = computed(() => (value: string) => getDataTypeOptionsLabel(value)) // 解析数据类型

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    queryParams.deviceCategoryId = deviceCategoryId
    const data = await DeviceAttrModelApi.getDeviceAttrModelPage(queryParams)
    list.value = data.list
    list.value.forEach(function (item,index){
      if(item.isSum!=1){
        list1.value.push(item)
      }
    })
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  queryParams.type = undefined
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number,name?:string,list?:[]) => {
  name = categoryName;
  list = list1;
    formRef.value.open(type,id,name,list)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {

    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await DeviceAttrModelApi.deleteDeviceAttrModel(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(() => {
  if (!deviceCategoryId) {
    message.warning('参数错误，设备属性模板不能为空！')
    delView(unref(currentRoute))
    return
  }
  getList()
})
</script>
